unit atick;

interface

function systicks():integer;

implementation
uses
  {$IFDEF MSWINDOWS}Windows{$ENDIF}
  {$IFDEF LINUX}Libc{$ENDIF};

function systicks():integer;
{$IFDEF LINUX}
var td:TTimeVal;
    tz:TTimeZone;
    n:int64;
{$ENDIF}
begin
{$IFDEF LINUX}
  gettimeofday(td,{$IFDEF fpc}@{$ENDIF}tz);
  n:=int64(td.tv_sec) * int64(1000)+int64(td.tv_usec div 1000);//td.tv_usec div 1000;
  Result:=integer(n);
{$ENDIF}
{$IFDEF MSWINDOWS}
  Result:=Windows.GetTickCount();
{$ENDIF}
end;

end.
