
// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the NCCONV_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// NCCONV_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.



#ifdef __GNUC__
    #define NCCONV_API
    #define NCCONV_API_ATTR __attribute__ ((stdcall))
#else
    #define NCCONV_API_ATTR
    #ifdef NCCONV_EXPORTS
	#define NCCONV_API __declspec(dllexport) __stdcall
    #else
        #define NCCONV_API __declspec(dllimport) __stdcall
    #endif
#endif

#if defined(__cplusplus)
extern "C" {
#endif

int NCCONV_API cnvInit(const PUniChromEntryTable uci) NCCONV_API_ATTR;

int NCCONV_API cnvImport(int nFormatId, const PCHAR FileName, HSpec Asp) NCCONV_API_ATTR;

int NCCONV_API cnvExport(int nFormatId, const PCHAR FileName, HSpec Asp) NCCONV_API_ATTR;

int NCCONV_API cnvEnumFormats(int nFormatId, PCHAR FormatName, int* bufsize, int* flags) NCCONV_API_ATTR;

#if defined(__cplusplus)
}
#endif

