library SampADC;

uses
  Types,devtypes;

{$R *.res}

var
  fDebugFunction:TDebugWriteStr;
  fDebugClient:Pointer;

  function drvOpenEx(ADebugFunction:TDebugWriteStr;AClient:Pointer):BOOL;stdcall;
  begin
    fDebugFunction:=ADebugFunction;
    fDebugClient:=AClient;
    Result:=true;
  end;

  function drvClose:BOOL;stdcall;
  begin
    Result:=true;
  end;

  function drvOpenInstrument(AProfile:integer;AnAction:TPageNotify;AClient:pointer):integer;stdcall;
  begin
    Result:=AProfile+1;
  end;

  function drvCloseInstrument(HInstrument:integer):BOOL;stdcall;
  begin
    Result:=true;
  end;

  function drvOpenInt32ChannelEx(HInstrument:IHandle;AnAction:TInt32Callback;AClient:pointer;AChannel:integer):BOOL;stdcall;
  begin
    Result:=true;
  end;

  function drvCloseChannelEx(HInstrument:IHandle;AChannel:integer):BOOL;stdcall;
  begin
    Result:=true;
  end;

  function drvGetChannelInfo(HInstrument:IHandle;AChannel:integer;var DevInfo:TDeviceInfo):BOOL;stdcall;
  begin
    DevInfo.DevType:=0;
    DevInfo.FullScale:=$FFFFFF;
    DevInfo.DevMin:=-3.0;
    DevInfo.DevMax:=+3.0;
    Result:=true;
  end;

  function drvGetChannelFrequency(HInstrument:IHandle;AChannel:integer):single;stdcall;
  begin
    Result:=20;
  end;

  function drvSetChannelFrequency(HInstrument:IHandle;AChannel:integer;freq:single):single;stdcall;
  begin
    Result:=20;
  end;

exports
  drvOpenEx,
  drvClose,
  drvOpenInstrument,
  drvCloseInstrument,
  drvOpenInt32ChannelEx,
  drvCloseChannelEx,
  drvGetChannelInfo,
  drvGetChannelFrequency,
  drvSetChannelFrequency;

begin

end.
